#include <stdlib.h>
#include <iostream>
#include <atomic> 
#include <thread> 
#include <vector> 
using namespace std;

atomic<int> global_counter( 0 );

void increase_global( int n ) { 
   for( int i = 0; i < n; ++i ) ++global_counter;
}

void increase_reference( atomic<int>& var, int n ) {
   for( int i = 0; i < n; ++i ) ++var;
}

int main( int argc, char* argv[] ) {
   const int incr = 100000;
   vector<thread> threads;
   int numb = 10; 
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) 
      numb = atoi( argv[ 1 ] );
   cout << "инкремент глобального счётчика в " << numb << " потоков..." << endl;
   for( int i = 1; i <= numb; ++i )
      threads.push_back( thread( increase_global, incr ) );
   cout << "инкремент параметра функции потока в " << numb << " потоков..." << endl;
   atomic<int> local( 0 );
   for( int i = 1; i <= numb; ++i )
      threads.push_back( thread( increase_reference, ref( local ), incr ) ); 
   cout << "синхронизация завершения..." << endl;
   for( auto& th : threads ) th.join(); 
   cout << "глобальный счётчик = " << global_counter << endl;
   cout << "локальный счётчик = " << local << endl;
   return 0;
}
